## openjdk-26 26~9ea

=== debian/changelog ===
openjdk-26 (26~9ea-1) experimental; urgency=medium

  * OpenJDK 26 snapshot, build 9.

  [ Vladimir Petko ]
  * d/*: update openjdk version to 26.
  * copyright-gen.py: add supported openjdk versions.
  * d/p/jdk-8359735.patch: drop patch applied upstream
  * d/p/power-opt.diff: refresh patch.
  * d/t/problems.csv: add openjdk-26.
  * d/*: regenerate control files and test scripts.

  [ Matthias Klose ]
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 05 Aug 2025 08:35:23 +0200

openjdk-25 (25~32ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 32.

  [ Vladimir Petko ]
  * d/p/jdk-8359735-proposed.patch: Fix process tests failing in Ubuntu 25.10.
  * d/rules: Add -XX:TieredStopAtLevel=1 to boot jdk args for s390x to work
    around an Ubuntu LP builder issue.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Jul 2025 13:45:05 +0200

openjdk-25 (25~25ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 25.
  * Prefer OpenJDK 25 as a build dependency. Closes: #1106303.

 -- Matthias Klose <doko@debian.org>  Sat, 31 May 2025 11:40:07 +0200

openjdk-25 (25~22ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 22.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 11 May 2025 12:03:44 +0200

openjdk-25 (25~20ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 20.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Apr 2025 05:43:35 +0200

openjdk-25 (25~17ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 17.

  * Honour DEB_BUILD_OPTIONS=parallel=N while running jtreg tests (Helmut
    Grohne). Closes: #1095920.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Apr 2025 08:42:24 +0200

openjdk-25 (25~16ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 16.

  [ Vladimir Petko ]
  * d/p/jdk-8352800-proposed.patch: Add missing header.
  * d/p/test-empty-path.patch: Disable tests that require access to
    getFileStore(path) due to JDK-8166162.
  * d/t/jtreg-autopkgtest.*: Set ulimit -c unlimited for
    runtime/ErrorHandling/CreateCoredumpOnCrash.java.
  * d/t/problems.csv: Disable tests failing due to upstream bugs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 Mar 2025 19:35:18 +0100

openjdk-25 (25~15ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 15.
  * Fix some lintian warnings.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 23 Mar 2025 06:46:09 +0100

openjdk-25 (25~14ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 14.
  * debian/tests: Regenerate test files for 25.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Mar 2025 08:13:37 +0100

openjdk-25 (25~10ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 10.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Feb 2025 22:19:23 +0100

openjdk-25 (25~9ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 9.

  [ Pushkar Kulkarni ]
  * d/control: New graal-builder jdk package.
  * d/rules: Generate graal-builder jdk package.

  [ Matthias Klose ]
  * Fix jvmci package description.
  * Clean up jvmci package.
  * Install changelog and copyright for jvmci.
  * Remove some man pages, that appear with 24~36ea without binaries:
    jabswitch.1, jaccess*.1, kinit.1, klist.1, ktab.1.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 09 Feb 2025 20:32:32 +0100

openjdk-25 (25~8ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 8.
  * Disable explicit power8 optimization on ppc64el.
  * Build zero with --disable-precompiled-headers.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 02 Feb 2025 13:57:28 +0100

openjdk-25 (25~7ea-1) unstable; urgency=medium

  * OpenJDK 25 snapshot, Build 7.

  [ Vladimir Petko ]
  * d/p/jdk-8347014-proposed.patch: Define MAP_FIXED_NOREPLACE_value for alpha.
  * d/t/problems.csv: Add openjdk-24 and openjdk-25 to the problems.csv.
  * d/rules: Dump complete hs_err_pid and replay_pid logs to stdout.
  * d/t/problems.csv: Fix typo - remove jdk prefix for
    sun/security/util/Debug/DebugOptions.java.
  * d/rules: Disable dtrace on jammy armhf (was not enabled before and cannot
    be built due to a GCC ICE (see LP #2091225).

  [ Matthias Klose ]
  * Try to work-around a ftbfs on alpha. For now we keep the
    zero-alpha-workaround patch enabled instead of jdk-8347014-proposed.
  * d/rules: Also dump logs for zero builds and for build failures.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2025 21:12:03 +0100

openjdk-25 (25~4ea-1) experimental; urgency=medium

  * OpenJDK 25 snapshot, Build 4.

  [ Vladimir Petko ]
  * d/rules: Set JVM thread size and Java thread size for power architectures and S390x
    to avoid a stack overflow error.

  [ Matthias Klose ]
  * d/rules: Also do the above fix for alpha and sparc64.
  * Try to work-around a ftbfs on alpha.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 13:09:04 +0100

openjdk-25 (25~0ea-1) experimental; urgency=medium

  * OpenJDK 25 snapshot, Build 0.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Dec 2024 11:27:05 +0100

openjdk-24 (24~26ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 26.

  [ Matthias Klose ]
  * d/patches/{atk-wrapper-security,update-permission-test}: Disable.
  * d/patches/warn-fontmanager: Update.

  [ Pushkar Kulkarni ]
  * For jammy, work around GCC ICE on armhf. See LP #1953128.
  * d/t/problems.csv: Update based on recent JTREG runs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Nov 2024 12:21:53 +0100

openjdk-24 (24~22ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 22.
  * Consolidate setting of dtrace architectures.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 01 Nov 2024 10:57:23 +0100

openjdk-24 (24~20ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 20.

  [ Vladimir Petko ]
  * d/rules: Do not include dtrace support for S390x (JDK-8305174).
  * d/t/problems.csv: Disable jdk/sun/security/util/Debug/DebugOptions.java
    due to JDK-8339713.
  * d/rules: Disable hotspot for i386 (JDK-8341871).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2024 09:05:23 +0200


