## openjdk-26 26~12ea

=== debian/changelog ===
openjdk-26 (26~12ea-1) unstable; urgency=medium

  * OpenJDK 26 snapshot, build 12.
  * Build using GCC 15 on development releases.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 26 Aug 2025 10:15:58 +0200
